%define section devel

Summary:        AOP for Java
Name:           aspectwerkz
Version:        0.9
Release:        1jpp
Epoch:          0
License:        BSD-style License
URL:            http://aspectwerkz.codehaus.org/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        aspectwerkz-0.9.tar.gz
Source1:        aspectwerkz-0.9-doc.tar.gz
#Source2:        aspectwerkz-missing-testinput.xml
Patch0:         aspectwerkz-build_xml.patch
Patch1:         aspectwerkz-AspectC.patch
Patch2:         aspectwerkz-Context.patch
Patch3:         aspectwerkz-BcelMetaDataMaker.patch
Patch4:         aspectwerkz-TransformationUtil.patch
Patch5:         aspectwerkz-jisp2.patch
#Patch6:         aspectwerkz-cltools.patch
BuildRequires:  jpackage-utils >= 0:1.5.37, junit >= 0:3.8.1
BuildRequires:  ant >= 0:1.5.4, ant-optional >= 0:1.5.4
BuildRequires:  java-1.4.2-bea >= 0:1.4.2
BuildRequires:  java-1.4.2-sun-devel >= 0:1.4.2
BuildRequires:  attrib4j >= 0:0.9.0
BuildRequires:  bcel >= 0:5.1
BuildRequires:  jakarta-commons-jexl >= 0:1.0
BuildRequires:  concurrent >= 0:1.3.2
BuildRequires:  dom4j >= 0:1.4
BuildRequires:  jaxen >= 0:1.0
BuildRequires:  saxpath >= 0:1.0
BuildRequires:  jisp2 >= 0:2.5.1
BuildRequires:  jrexx >= 0:1.1.1
BuildRequires:  piccolo >= 0:1.03
BuildRequires:  qdox >= 0:1.4
BuildRequires:  gnu.trove >= 0:1.0.2
BuildRequires:  junitperf >= 0:1.8
Requires:  attrib4j >= 0:0.9.0
Requires:  bcel >= 0:5.1
Requires:  jakarta-commons-jexl >= 0:1.0
Requires:  concurrent >= 0:1.3.2
Requires:  dom4j >= 0:1.4
Requires:  jaxen >= 0:1.0
Requires:  saxpath >= 0:1.0
Requires:  jisp2 >= 0:2.5.1
Requires:  jrexx >= 0:1.1.1
Requires:  piccolo >= 0:1.03
Requires:  qdox >= 0:1.4
Requires:  gnu.trove >= 0:1.0.2
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
AspectWerkz is a dynamic, lightweight and 
high-performant AOP/AOSD framework for Java. 
AspectWerkz utilizes runtime bytecode modification 
to weave your classes at runtime. It hooks in and 
weaves classes loaded by any class loader except 
the bootstrap class loader. It has a rich join 
point model. Aspects, advices and introductions 
are written in plain Java and your target classes 
can be regular POJOs. You have the possibility to 
add, remove and re-structure advices as well as 
swapping the implementation of your introductions at 
runtime. Your aspects can be defined using either an 
XML definition file or using Runtime Attributes. 


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation

%description demo
%{summary}.

%prep
%setup -q -n %{name}
# remove all binary libs
find ./lib -name "*.jar" -exec rm -f {} \;
# unpack maven-generated docs
gzip -dc %{SOURCE1} | tar -xf -
#cp bin/aspectwerkz bin/aspectwerkz.test
#cp %{SOURCE2} src/samples/aspectwerkz.xml
cp build.xml build.xml.sav
cp src/main/org/codehaus/aspectwerkz/attribdef/definition/AspectC.java src/main/org/codehaus/aspectwerkz/attribdef/definition/AspectC.java.sav
cp src/main/org/codehaus/aspectwerkz/transform/Context.java src/main/org/codehaus/aspectwerkz/transform/Context.java.sav
cp src/main/org/codehaus/aspectwerkz/metadata/BcelMetaDataMaker.java src/main/org/codehaus/aspectwerkz/metadata/BcelMetaDataMaker.java.sav
cp src/main/org/codehaus/aspectwerkz/transform/TransformationUtil.java src/main/org/codehaus/aspectwerkz/transform/TransformationUtil.java.sav

%patch0
%patch1
%patch2
%patch3
%patch4
%patch5

%build
export ASPECTWERKZ_HOME=$RPM_BUILD_DIR/%{name}-%{version}
export CLASSPATH=$(build-classpath \
attrib4j \
bcel \
commons-jexl \
concurrent \
dom4j \
jaxen \
saxpath \
jisp2 \
jrexx \
piccolo \
qdox \
gnu.trove \
junitperf \
junit)
CLASSPATH=$CLASSPATH:/usr/lib/jvm/java-1.4.2-bea/jre/lib/managementapi.jar
ant -Dbuild.sysclasspath=first \
aspectwerkz:test \
java:javadoc
#aspectwerkz:transform \
#aspectwerkz:jar \
#aspectwerkz:test:perf \
#aspectwerkz:samples:introduction \
#aspectwerkz:samples:logging \
#aspectwerkz:samples:caching \
#aspectwerkz:samples:asynchronous \
#aspectwerkz:samples:synchronization \
#aspectwerkz:samples:cflow \
#aspectwerkz:samples:transparentpersistence \
#aspectwerkz:attributes:samples \
#aspectwerkz:attributes:extensions \
#aspectwerkz:test:clapp \

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p lib/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p lib/%{name}-core-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
cp -p target/extensions.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-extensions-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p bin/aspectwerkz $RPM_BUILD_ROOT%{_bindir}


# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/docs/apidocs

# demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/src
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/bin
cp -p target/samples.jar $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib
cp -pr src/samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/src
cp -p bin/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/bin

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

# -----------------------------------------------------------------------------

%changelog

* Sat Jun 12 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.9-1jpp
- Upgrade to 0.9

* Wed Apr 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.1-2jpp
- _javadir ownership correction thanks to Kaj J. Niemi

* Sat Feb 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.1-1jpp
- First JPackage release
